
DIST_NAME		:= dist
DIST_SRC		:= $(PATH_SRC)/$(DIST_NAME)
DIST_BIN		:= $(PATH_BIN)/$(DIST_NAME)
DIST_OUT		:= $(PATH_BIN)/$(DIST_NAME).tar.gz
DIST_INC		:= all.sr8 ascii.sr8 readme.txt veld.sr8 veldback.4bp
DIST_INC_BIN	:= $(patsubst %,$(DIST_BIN)/%,$(DIST_INC))
DIST_INC_SRC	:= $(patsubst %,$(DIST_SRC)/%,$(DIST_INC))
DIST_TARA_BIN	:= $(DIST_BIN)/tara.com
DIST_TARA_SRC	:= $(PATH_BIN)/tara/tara.com
BUILD_HELP		+= \\n\\t* $(DIST_OUT)

$(DIST_BIN):
	$(call mb_mkdir,$(DIST_BIN))
$(DIST_BIN)/all.sr8: $(DIST_SRC)/all.sr8 | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_BIN)/ascii.sr8: $(DIST_SRC)/ascii.sr8 | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_BIN)/veld.sr8: $(DIST_SRC)/veld.sr8 | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_BIN)/veldback.4bp: $(DIST_SRC)/veldback.4bp | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_BIN)/readme.txt: $(DIST_SRC)/readme.txt | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_TARA_BIN): $(DIST_TARA_SRC) | $(DIST_BIN)
	$(call mb_copy,$<,$@)
$(DIST_OUT): $(DIST_INC_BIN) $(DIST_TARA_BIN)
	$(call mb_create_dist,$(DIST_OUT),$(DIST_BIN))
