;-=;=;=;=;=;=;=;=P;

	.db	254
UPDATE:
	LD	IX,#TANK1+16
UPDATELOOP:
	CALL	UPDATE_TANKS

	LD	DE,#16
	ADD	IX,DE
	LD	HL,#UPDATE-1
	DEC	(HL)
	JP	NZ,UPDATELOOP

	LD	A,#254
	LD	(UPDATE-1),A
	RET

UPDATE_TANKS:
	LD	A,7(IX)	; TNK NR
	OR	A
	RET	Z		; GEEN TANK 

	BIT	5,9(IX)
	JP	NZ,DO_OFFSET_MOVE

	BIT	7,9(IX)
	JP	NZ,DO_ATT

	JP	CHECK_MOVE
	RET

;------


DO_OFFSET_MOVE:
	LD	A,10(IX)
	CALL	TNK_TO_IY
	LD	C,3(IY)

	LD	A,4(IX)
	OR	A
	JR	Z,DO_Y

	BIT	7,A
	JR	NZ,DO_NEGX

	SUB	C
	SUB	C
DO_NEGX:
	ADD	C
	LD	4(IX),A
DO_Y:
	LD	A,5(IX)
	OR	A
	JR	Z,DO_STOP
	BIT	7,A

	JR	NZ,DO_NEGY

	SUB	C
	SUB	C
DO_NEGY:
	ADD	C
	LD	5(IX),A
	RET
DO_STOP:
	LD	A,4(IX)
	OR	A
	RET	NZ
	RES	5,9(IX)
	RET

;=========================================================================

DO_ATT:
	LD	A,8(IX)
	CALL	A_TO_IY

	;LD	A,10(IX)
	;AND	#0b11100000
	;SRL	A
	;SRL	A
	;LD	C,A
	;LD	B,#0
	;LD	HL,#TANK_TAB

	LD	A,0(IY)
	DEC	A
	LD	2(IX),A
	LD	A,1(IY)
	DEC	A
	LD	3(IX),A
	
	RES	7,9(IX)

	RET


;=========================================================================

CHECK_MOVE:
	LD	BC,#0

	LD	A,0(IX)
	SUB	2(IX)
	SLA	A
	RL	B
	SRL	A
	LD	D,A	; X NOG RIJDEN

	LD	A,1(IX)
	SUB	3(IX)
	SLA	A
	RL	C	; OF RR
	SRL	A
	LD	E,A	; Y NOG TE RIJDEN

	LD	A,D
	OR	E
	JR	NZ,DO_MOVE

	LD	A,R
	AND	#0b10101111
	RET	NZ
	LD	A,R
	AND	#0b00000001
	JR	Z,DRAAI_UP
DRAAI_DO:
	LD	A,10(IX)
	AND	#7
	DEC	A
	AND	#7
	LD	B,A
	LD	A,10(IX)	; RONDJES DRAAI'EN
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	RET
DRAAI_UP:
	LD	A,10(IX)
	AND	#7
	INC	A
	LD	B,A
	LD	A,10(IX)	; RONDJES DRAAI'EN
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	RET
; DE = X,Y DAT DE TANK NOG MOET RIJDEN
; BC = CARRY POS/NEG

DO_MOVE:
	EXX
	LD	B,0(IX)
	LD	C,1(IX)
	CALL	CALC_ADR
	PUSH	HL

	LD	A,(HL)
	AND	#0xF0
	CALL	MAKE_RADAR_CL
	EX	AF,AF

	EXX
	POP	HL		; KON NIET SNELLER

	LD	A,D
	OR	A
	JR	Z,CHK_MOVE_Y
	LD	A,E
	OR	A
	JR	Z,CHK_MOVE_X

	LD	D,H		;TANK ADR
	LD	E,L

	XOR	A
	OR	B
	JR	NZ,CHK_MOVE_SCHUIN
	OR	C
	JP	NZ,CHK_MOVE_POS5
	JP	CHK_MOVE_POS7

CHK_MOVE_SCHUIN:
	XOR	A	
	OR	C
	JP	NZ,CHK_MOVE_POS3
	JP	CHK_MOVE_POS1

CHK_MOVE_X:
	LD	D,H		;TNK ADR
	LD	E,L
	XOR	A
	OR	B
	JP	NZ,CHK_MOVE_POS2
	JP	CHK_MOVE_POS6
CHK_MOVE_Y:
	LD	D,H
	LD	E,L		;TNK ADR
	XOR	A
	OR	C
	JP	NZ,CHK_MOVE_POS4
	JP	CHK_MOVE_POS0

;=========================================================================

CHK_MOVE_POS0:
	CALL	CHK_POS0
	CALL 	CHK_POS1
	CALL	CHK_POS7
	LD	A,R
	BIT	4,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS2
	CALL	CHK_POS6
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS1:
	CALL	CHK_POS1
	CALL 	CHK_POS2
	CALL	CHK_POS0
	LD	A,R
	BIT	3,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS3
	CALL	CHK_POS7
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS2:
	CALL	CHK_POS2
	CALL 	CHK_POS3
	CALL	CHK_POS1
	LD	A,R
	BIT	4,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS4
	CALL	CHK_POS0
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS3:
	CALL	CHK_POS3
	CALL 	CHK_POS4
	CALL	CHK_POS2
	LD	A,R
	BIT	3,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS5
	CALL	CHK_POS1
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS4:
	CALL	CHK_POS4
	CALL 	CHK_POS5
	CALL	CHK_POS3
	LD	A,R
	BIT	4,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS6
	CALL	CHK_POS2
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS5:
	CALL	CHK_POS5
	CALL 	CHK_POS6
	CALL	CHK_POS4
	LD	A,R
	BIT	3,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS7
	CALL	CHK_POS3
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS6:
	CALL	CHK_POS6
	CALL 	CHK_POS7
	CALL	CHK_POS5
	LD	A,R
	BIT	4,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS0
	CALL	CHK_POS4
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST
CHK_MOVE_POS7:
	CALL	CHK_POS7
	CALL 	CHK_POS0
	CALL	CHK_POS6
	LD	A,R
	BIT	3,A
	CALL	Z,CHK_MOVE_POSR
	CALL	CHK_POS1
	CALL	CHK_POS5
	CALL	CHK_AFWK	
	JP	TANK_VAST	; TANK VAST

TANK_VAST:
	CALL	COLOR_BLAU
	LD	B,0(IX)
	LD	C,1(IX)	
	LD	2(IX),B
	LD	3(IX),C
	RET

CHK_MOVE_POSR:
	EXX
	POP	AF
	LD	A,R
	SLA	A
	AND	#0b00001011
	LD	D,#0
	LD	E,A
	LD	HL,#MOVE_POSR_TAB
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	PUSH	DE
	EXX
	RET

MOVE_POSR_TAB:
	.dw	CHK_MOVE_POS4
	.dw	CHK_MOVE_POS3
	.dw	CHK_MOVE_POS7
	.dw	CHK_MOVE_POS2
	.dw	CHK_MOVE_POS6
	.dw	CHK_MOVE_POS1
	.dw	CHK_MOVE_POS0
	.dw	CHK_MOVE_POS5

;=========================================================================


CHK_POS0:
	LD	H,D		; DE BLIJFT HETZELFDE
	LD	L,E		; EN VANUIT HL REKEN JE
	DEC	H
	DEC	H
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL		; BACK 2 TNK
	LD	A,(HL)		; CHK OP TNK
	OR	A
	JP	Z,DO_MOVE_POS0
	RET
CHK_POS1:
	LD	H,D
	LD	L,E
	DEC	H
	DEC	H
	INC	HL
	INC	HL
	INC	HL
	INC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS1
	RET
CHK_POS2:
	LD	H,D
	LD	L,E
	INC	HL
	INC	HL
	INC	HL
	INC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS2
	RET
CHK_POS3:
	LD	H,D
	LD	L,E
	INC	H
	INC	H
	INC	HL
	INC	HL
	INC	HL
	INC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS3
	RET
CHK_POS4:
	LD	H,D
	LD	L,E
	INC	H
	INC	H
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS4
	RET
CHK_POS5:
	LD	H,D
	LD	L,E
	INC	H
	INC	H
	DEC	HL
	DEC	HL
	DEC	HL
	DEC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS5
	RET
CHK_POS6:
	LD	H,D
	LD	L,E
	DEC	HL
	DEC	HL
	DEC	HL
	DEC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS6
	RET
CHK_POS7:
	LD	H,D
	LD	L,E
	DEC	H
	DEC	H
	DEC	HL
	DEC	HL
	DEC	HL
	DEC	HL
	LD	A,(HL)
	CP	#80
	RET	NC		; CHK OP BUILDINGS ENZO
	INC	HL
	LD	A,(HL)
	OR	A
	JP	Z,DO_MOVE_POS7
	RET

CHK_AFWK:
	RET
	

;=========================================================================

DO_MOVE_POS0:
	INC	DE		; TO TNK LAYER

	CALL	UPDATE_RADAR_ORG

	SET	5,9(IX)	; MOVE OP PIXELS

	LD	A,(DE)		; NR TANK	(IS IX+7 MAAR DIT IS SNELLER !!)
	LD	(HL),A		; ON NEW VLAK

	XOR	A
	LD	(DE),A		; RES TANK LAY

	DEC	1(IX)		; Y=Y-1
	LD	4(IX),A	; OFFSET X=0
	LD	5(IX),#15	; OFFSET Y=15

	LD	A,10(IX)
	AND	#0b11111000	; RICHTING = 0
	LD	10(IX),A	

	CALL	UPDATE_RADAR

	POP	HL		; STACK

	DEC	DE		; 2 VELD LAY
	LD	A,(DE)
	CP	#4
	RET	NC		; CHK OP OPEN RUIMTE
	LD	A,#1
	LD	(DE),A		; PUT TRACKS
	RET

DO_MOVE_POS1:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A			
	INC	0(IX)
	DEC	1(IX)
	LD	4(IX),#-15
	LD	5(IX),#15
	LD	B,#1
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	CP	#4
	RET	NC
	LD	A,#2
	LD	(DE),A
	RET

DO_MOVE_POS2:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A	
	INC	0(IX)
	LD	4(IX),#-15
	LD	5(IX),#0
	LD	B,#2
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	CP	#4
	RET	NC
	LD	A,#3
	LD	(DE),A
	RET

DO_MOVE_POS3:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A	
	INC	0(IX)
	INC	1(IX)
	LD	4(IX),#-15
	LD	5(IX),#-15
	LD	B,#3
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	CP	#4
	RET	NC
	LD	A,#4
	LD	(DE),A
	RET

DO_MOVE_POS4:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A	
	INC	1(IX)
	LD	4(IX),#0
	LD	5(IX),#-15
	LD	B,#4
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	OR	A
	RET	NZ
	INC	A
	LD	(DE),A
	RET

DO_MOVE_POS5:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A	
	DEC	0(IX)
	INC	1(IX)
	LD	4(IX),#15
	LD	5(IX),#-15
	LD	B,#5
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	OR	A
	RET	NZ
	LD	A,#2
	LD	(DE),A
	RET

DO_MOVE_POS6:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A
	DEC	0(IX)
	LD	4(IX),#15
	LD	5(IX),#0
	LD	B,#6
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	OR	A
	RET	NZ
	LD	A,#3
	LD	(DE),A
	RET

DO_MOVE_POS7:
	INC	DE
	CALL	UPDATE_RADAR_ORG
	SET	5,9(IX)
	LD	A,(DE)
	LD	(HL),A
	XOR	A
	LD	(DE),A
	DEC	0(IX)
	DEC	1(IX)
	LD	4(IX),#15
	LD	5(IX),#15
	LD	B,#7
	LD	A,10(IX)
	AND	#0b11111000
	OR	B
	LD	10(IX),A
	CALL	UPDATE_RADAR
	POP	HL
	DEC	DE
	LD	A,(DE)
	OR	A
	RET	NZ
	LD	A,#4
	LD	(DE),A
	RET



UPDATE_RADAR_ORG:
	LD	A,(DE)
	AND	#0b11000000	; CHK OP EIGEN KLEUR
	RET	NZ

	EXX
	XOR	A
	LD	HL,#0x2180 	; EESTE ADR RADAR
	LD	D,1(IX)	; *256
	LD	E,0(IX)
	SLA	D	; *512
	RLA
	SLA	D	; *1024
	RLA
	ADD	HL,DE	; Y
	RLA
	SET	7,A	; NO INC
	LD	B,A
	XOR	A
	DI
	OUT	(0x64),A
	LD	A,L
	OUT	(0x63),A
	LD	A,H
	OUT	(0x63),A
	LD	A,B
	OUT	(0x63),A
	EX	AF,AF
	OUT	(0x60),A
	LD	C,A
	XOR	A
	OUT	(0x64),A
	LD	A,L
	OUT	(0x63),A
	LD	A,H
	ADD	#2
	OUT	(0x63),A
	LD	A,B
	OUT	(0x63),A
	LD	A,C
	OUT	(0x60),A
	EI
	EXX
	RET

UPDATE_RADAR:
	LD	A,(HL)
	AND	#0b11000000
	RET	NZ

	EXX
	XOR	A
	LD	HL,#0x2180 	; EESTE ADR RADAR
	LD	D,1(IX)	; *256
	LD	E,0(IX)
	SLA	D	; *512
	RLA
	SLA	D	; *1024
	RLA
	ADD	HL,DE	; Y
	RLA
	SET	7,A	; NO INC
	LD	B,A
	XOR	A
	DI
	OUT	(0x64),A
	LD	A,L
	OUT	(0x63),A
	LD	A,H
	OUT	(0x63),A
	LD	A,B
	OUT	(0x63),A
	LD	A,#255
	OUT	(0x60),A
	XOR	A
	OUT	(0x64),A
	LD	A,L
	OUT	(0x63),A
	LD	A,H
	ADD	#2
	OUT	(0x63),A
	LD	A,B
	OUT	(0x63),A
	LD	A,#255
	OUT	(0x60),A
	EI
	EXX

	PUSH	DE

	DEC	HL
	DEC	HL

	LD	A,#5
	LD	BC,#SEE_RADAR
UPDATE_RADAR_LP:
	EX	AF,AF
	LD	A,(BC)
	LD	E,A
	INC	BC
	LD	A,(BC)
	LD	D,A
	INC	BC

	ADD	HL,DE
	XOR	A
	LD	(HL),A	
	SBC	HL,DE

	EX	AF,AF
	DEC	A
	JR	NZ,UPDATE_RADAR_LP

	POP	DE
	RET


SEE_RADAR:
	.dw	0,4,-4,512,-512



COLOR_TNK_TAB:
	.db	8
	.db	8+64
	.db	8+128
	.db	255

TANK_TAB:
	.db	0	; TIMER				TRIKE
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	5	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE 

	.db	0	; TIMER				QUAD
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	3	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE 

	.db	0	; TIMER				TANK
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	3	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE
 
	.db	0	; TIMER				SIEGE
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	1	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE

	.db	0	; TIMER				XXXXX
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	3	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE  

	.db	0	; TIMER				XXXXX
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	3	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE 

	.db	0	; TIMER				XXXXXXX
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	3	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE 

	.db	0	; TIMER				HARV
	.db	0	; SHIELD
	.db	0	; SHOT POWER
	.db	1	; SPEED
	.db	0	; BUILD TIME
	.db	0	; COST
	.db	0	; CAN BE BUILD AFTER BIT xx
	.db	0	; SEE GATE 
