
TARA_NAME	:= tara
TARA_SRC	:= $(PATH_SRC)/$(TARA_NAME)
TARA_BIN	:= $(PATH_BIN)/$(TARA_NAME)
TARA_HEX	:= $(TARA_BIN)/$(TARA_NAME).hex
TARA_COM	:= $(TARA_BIN)/$(TARA_NAME).com
TARA_RELS	:= $(TARA_BIN)/$(TARA_NAME).rel
TARA_CODE	:= $(TARA_SRC)/$(TARA_NAME).asm
BUILD_HELP	+= \\n\\t* $(TARA_COM)

$(TARA_BIN):
	$(call mb_mkdir,$(TARA_BIN))

$(TARA_BIN)/%.rel: $(TARA_SRC)/%.asm | $(TARA_BIN)
	$(call mb_compile_asm,$@,$<)

$(TARA_HEX): $(TARA_RELS)
	$(call mb_link_asm_dos,$(TARA_HEX),$(TARA_RELS))

$(TARA_COM): $(TARA_HEX)
	$(call mb_hex2com,$(TARA_HEX),$(TARA_COM))
