ADR:
	.dw	0x4000
BUILD:
	;CALL	CAPS_ON
	CALL	DO_SWAP
	CALL	BUILD_VELD
	CALL	TANKS
	CALL	BULLETS
	;CALL	MSEL
	CALL	SETPAGE
	;CALL	CAPS_OFF

	LD a,(#BUILD_CNT)
	inc a
	LD (#BUILD_CNT),a

	LD a,(#SEC_OLD)
	LD b,a
	LD a,(#SEC_CNT)
	cp b
	JP	Z,BUILD_END
	LD (#SEC_OLD),a

	;LD a,(#INT_TICK)
	;cp #1
	;JP	NZ,BUILD_END
	;xor a
	;LD (#INT_TICK),a

	LD a,(#SEC_CNT)
	ADD #'0'
	ld	e,A
	ld	c,#_CONOUT
	call	5

	ld	e,#'-'
	ld	c,#_CONOUT
	call	5

	LD a,(#BUILD_CNT)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	ADD #'0'
	ld	e,A
	ld	c,#_CONOUT
	call	5

	LD a,(#BUILD_CNT)
	and #0x0F
	ADD #'0'
	ld	e,A
	ld	c,#_CONOUT
	call	5

	ld	e,#'\n'
	ld	c,#_CONOUT
	call	5

	ld	e,#'\r'
	ld	c,#_CONOUT
	call	5

	;xor a
	;LD (#BUILD_CNT),a

BUILD_END:
	RET

INT_CNT:	.db	50
BUILD_CNT:	.db	0
SEC_CNT:	.db	0
SEC_OLD:   .db 0

MSEL:
	LD	HL,(MSEL_START_COR)
	LD	A,L
	OR	H
	RET	Z

	LD	B,#0
	LD	C,H
	SLA	H			;X
	RL	B
	LD	A,H
	LD	(M_DX),A
	LD	A,(PAGE)
	OR	B
	LD	(M_DX+1),A

	LD	A,L
	LD	(M_DY),A
	LD	DE,(MOUSEY)
	LD	A,C
	LD	BC,#0
	SUB	D
	RL	B
	LD	(M_NX),A
	LD	A,B
	ADD	A
	ADD	A
	LD	(M_ARG),A
	
	LD	HL,#MSEL_LINE
	JP	DO_CMD

BULLETS:
	RET
	LD	HL,#BULLETS_TAB+4
BULLETS_LP:
	LD	A,(HL)
	INC	HL
	LD	(B_DX),A
	LD	A,(HL)
	INC	HL
	LD	(B_DY),A
	LD	A,(HL)
	INC	HL
	LD	(B_NY),A
	LD	(B_NX),A
	EXX
	LD	HL,#BULLETS_CP
	CALL	DO_CMD
	EXX

	RET


BULLETS_TAB:
	.db	7,7,20,20,16,18,0,0,2	; SX,SY,DX,DY,TX,TY,OFFX,OFFY,TYPE (IN 16 :)
	.ds	128*7




TANKS:
	LD	HL,#CPYTT

	LD	A,#1
	LD	(T_SY+1),A	; 256
	LD	A,#1
	LD	(T_SX+1),A	; 256

	LD	A,(PAGE)
	LD	I,A		;INTERRUPT VECTOR

TANKS_LP:
	LD	A,(HL)
	OR	A
	RET	Z	; EINDE ALLE TANKS GEHAD

	LD	B,A
	LD	D,A

	AND	#0b10000000
	LD	E,A

	LD	A,D
	AND	#0b01000000
	SLA	A
	LD	D,A
	
	LD	A,B
	INC	HL
	CALL	A_TO_IX

	LD	A,10(IX)
	AND	#7
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	D
	LD	(T_SX),A	; richtimg tank

	LD	A,10(IX)
	AND	#0xE0
	SRL	A
	ADD	E
	LD	(T_SY),A	; type tank

	LD	A,#16
	LD	(T_NX),A
	LD	(T_NY),A

	LD	B,4(IX)	; OFFSET'S VAN AUTO'S
	LD	C,5(IX)

	LD	A,(VIEW_X)
	ADD	A
	LD	D,A
	LD	A,0(IX)
	SUB	D

	EX	DE,HL	; CPYTT IN DE

	CP	#-1
	JP	Z,TANKS_LE_OUT	; RAND LINKS ERUIT
	OR	A
	JP	Z,TANKS_LE_IN
	CP	#23
	JP	Z,TANKS_RI_IN
	CP	#24
	JP	Z,TANKS_RI_OUT

	CP	#16
	LD	L,A	
	JR	NZ,TANKS_ERR	; EVE SNEL ALS CALL  Z,TANKS_ERR (3M)

	LD	A,B
	AND	#0x0F
	JR	Z,TANKS_ERR
	BIT	7,4(IX)	; OFFSET = NEG
	JR	Z,TANKS_ERR
	RES	4,L
TANKS_ERR:
	LD	H,#0
	ADD	HL,HL		; MOET EVE 16 BIT :)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL

	LD	A,L
	ADD	B		; OFFSET
	LD	L,A
TANKS_X_CONT:
	LD	A,I		; PAGE
	OR	H
	LD	H,A

	LD	(T_DX),HL
	EX	DE,HL


;=====

	LD	A,(VIEW_Y)
	LD	D,A
	LD	A,1(IX)
	SUB	D
	CP	#-1
	JP	Z,TANKS_UP_OUT
	OR	A
	JP	Z,TANKS_UP_IN
	CP	#12
	JP	Z,TANKS_DO_IN
	CP	#13
	JP	Z,TANKS_DO_OUT

	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	C	; OFFSET Y
TANKS_Y_CONT:
	LD	(T_DY),A

	EXX
	LD	HL,#TNK_COPY
	CALL	DO_CMD

	BIT	0,9(IX)
	JR	Z,TANKS_POWER_READY		; SELECTED

	LD	HL,(T_DX)
	LD	(P_DX),HL	
	LD	A,(T_DY)
	LD	(P_DY),A

	LD	A,(T_NY)
	SRL	A
	SRL	A
	OR	A
	JR	Z,TANKS_POWER_READY		; MOET ANDERS !!!!
	LD	(P_NY),A

	LD	A,(T_NX)
	CP	#16
	JR	NZ,TANKS_POWER_READY		; MOET ANDERS !!!!

	LD	A,11(IX)
	SRL	A
	SRL	A
	SRL	A
	SRL	A
	OR	A
	CALL	Z,TANKS_POWER_INC
	LD	(P_NX),A

	LD	HL,#TNK_POWER
	CALL	DO_CMD


TANKS_POWER_READY:
	EXX
	CALL	COLOR_BLACK
	JP	TANKS_LP

TANKS_POWER_INC:
	INC	A
	RET

;=========================
;=========================
TANKS_LE_OUT:
	EX	DE,HL
	BIT	7,A		; OFFSET Y
	JP	NZ,TANKS_LP	; NEXT TANK

	LD	A,B
	OR	A
	JP	Z,TANKS_LP
	EX	DE,HL

	LD	(T_NX),A	; HOEVEEL COPY'EN WIJ
	CPL
	AND	#0x0F
	LD	B,A

	LD	A,(T_SX)
	ADD	B
	LD	(T_SX),A

	LD	HL,#0
	JP	TANKS_X_CONT
TANKS_LE_IN:
	LD	H,#0
	LD	L,B
	BIT	7,B
	JP	Z,TANKS_X_CONT	; TNK 2 LEFT

	LD	A,B
	CP	#-15
	EX	DE,HL
	JP	Z,TANKS_LP
	EX	DE,HL

	AND	#0x0F
	LD	(T_NX),A

	CPL
	AND	#0x0F
	LD	B,A
	LD	A,(T_SX)
	ADD	B
	LD	(T_SX),A

	LD	HL,#0
	JP	TANKS_X_CONT

TANKS_RI_OUT:
	EX	DE,HL
	BIT	7,B		; OFFSET Y
	JP	Z,TANKS_LP	; NEXT TANK

	LD	A,B
	CP	#-1
	JP	Z,TANKS_LP
	EX	DE,HL

	LD	HL,#384
	LD	A,L
	ADD	B
	LD	L,A

	LD	A,B
	CPL
	AND	#0x0F
	LD	(T_NX),A	; HOEVEEL COPY'EN WIJ

	JP	TANKS_X_CONT

TANKS_RI_IN:
	LD	HL,#368
	LD	A,L
	ADD	B
	LD	L,A
	BIT	7,B
	JP	NZ,TANKS_X_CONT

	LD	A,B
	CP	#15
	EX	DE,HL
	JP	Z,TANKS_LP
	EX	DE,HL

	CPL
	AND	#0x0F
	LD	(T_NX),A
	
	JP	TANKS_X_CONT


;----------------------------

TANKS_UP_OUT:
	BIT	7,C		; OFFSET Y
	JP	NZ,TANKS_LP	; NEXT TANK

	LD	A,C
	OR	A
	JP	Z,TANKS_LP

	LD	(T_NY),A	; HOEVEEL COPY'EN WIJ
	CPL
	AND	#0x0F
	LD	C,A

	LD	A,(T_SY)
	ADD	C
	LD	(T_SY),A

	XOR	A
	JP	TANKS_Y_CONT
TANKS_UP_IN:
	XOR	A
	ADD	C
	BIT	7,C
	JP	Z,TANKS_Y_CONT	; TNK 2 LEFT

	LD	A,C
	CP	#-15
	JP	Z,TANKS_LP

	AND	#0x0F
	LD	(T_NY),A

	CPL
	AND	#0x0F
	LD	C,A
	LD	A,(T_SY)
	ADD	C
	LD	(T_SY),A

	XOR	A
	JP	TANKS_Y_CONT



TANKS_DO_OUT:
	BIT	7,C		; OFFSET Y
	JP	Z,TANKS_LP	; NEXT TANK

	LD	A,C
	CP	#-1
	JP	Z,TANKS_LP

	LD	A,C
	CPL
	AND	#0x0F
	LD	(T_NY),A	; HOEVEEL COPY'EN WIJ

	LD	A,#208
	ADD	C
	JP	TANKS_Y_CONT

TANKS_DO_IN:
	LD	A,#192
	ADD	C
	BIT	7,C
	JP	NZ,TANKS_Y_CONT

	LD	A,C
	CP	#15
	JP	Z,TANKS_LP

	CPL
	AND	#0x0F
	LD	(T_NY),A

	LD	A,#192
	ADD	C
	JP	TANKS_Y_CONT



;---------------------

BUILD_VELD:
	LD	HL,#0
	LD	(DY),HL
	LD	(DX),HL

	LD	HL,(ADR)
	DEC	H
	DEC	H
	DEC	HL
	DEC	HL
	DEC	HL
	DEC	HL

	LD	DE,#CPYTT
	LD	B,#26 ; 24x13 = (384+128radar)512x208 on 512x212
	LD	C,#15
	LD	A,#-16	; ????
	LD	(DY),A
	LD	A,#1
	LD	(SY+1),A

	LD	A,(PAGE)
	LD	(DX+1),A
BUILD_XY:
	LD	A,(HL)	; BLACK LAYER
	OR	A
	JP	NZ,MAKE_BLACK

	LD	A,B
	CP	#26
	JP	Z,MAKE_TT
	CP	#1
	JP	Z,MAKE_TT

	LD	A,C
	CP	#15
	JP	Z,MAKE_TT
	CP	#1
	JP	Z,MAKE_TT

	INC	HL

	LD	A,(HL)	; VELD 
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	LD	(SX),A

	LD	A,(HL)
	AND	#0b11110000
	LD	(SY),A	; SY
	EXX
B_VDP_WAIT:
	IN	A,(0x65)
	RRCA
	JR	C,B_VDP_WAIT	; Command ready 

	DI
	LD	HL,#DO_COPY
	LD	A,#32
	OUT	(0x64),A	; reg nr.  
	LD	B,#21
	LD	C,#0x63

	OTIR
	EI

	LD	HL,(DX)
	LD	DE,#16
	ADD	HL,DE
	LD	(DX),HL

	EXX


	INC	HL
	LD	A,(HL)
	OR	A
	JR	Z,CONT_BUILD
	LD	(DE),A
	INC	DE

CONT_BUILD:
	INC	HL
	INC	HL

	DEC	B
	JR	NZ,BUILD_XY

	XOR	A
	LD	(DX),A	; EVE RESETEN
	LD	A,(DX+1)
	AND	#2
	LD	(DX+1),A

	LD	A,(DY)
	ADD	#16
	LD	(DY),A

	LD	A,C
	LD	BC,#512-26*4
	ADD	HL,BC
	LD	C,A

	LD	B,#26
	DEC	C
	JR	NZ,BUILD_XY

	XOR	A
	LD	(DE),A	; LAASTE ENTY

	RET
MAKE_TT:
	INC	HL
	INC	HL
	LD	A,(HL)
	OR	A
	JR	Z,CONT_BUILD

	LD	(DE),A
	INC	DE
	JR	CONT_BUILD

MAKE_BLACK:
	INC	HL
	INC	HL

	LD	A,B
	CP	#26
	JP	Z,CONT_BUILD
	CP	#1
	JP	Z,CONT_BUILD

	LD	A,C
	CP	#15
	JP	Z,CONT_BUILD
	CP	#1
	JP	Z,CONT_BUILD

	LD	A,#144
	LD	(SX),A
	XOR	A
	LD	(SY),A

	EXX

MAKE_BLACK_WAIT:
	IN	A,(0x65)
	RRCA
	JR	C,MAKE_BLACK_WAIT	; Command ready 

	DI
	LD	HL,#DO_COPY
	LD	A,#32
	OUT	(0x64),A	; reg nr.  
	LD	B,#21
	LD	C,#0x63

	OTIR
	EI

	LD	HL,(DX)
	LD	DE,#16
	ADD	HL,DE
	LD	(DX),HL

	EXX
	JR	CONT_BUILD



DO_SWAP:
	LD	A,(PAGE)
	OR	A
	LD	A,#0
	LD	(PAGE),A
	RET	NZ	; HIJ WAS 0 EN IS 0
	LD	A,#2	; bit 5=x8
	LD	(PAGE),A
	RET

PAGE:
	.db	0	; Y (R.21 BIT6)
SETPAGE:
	IN	A,(0x65)
	AND	#64
	JR	NZ,SETPAGE
SETPAGE_WAIT:
	IN	A,(0x65)
	AND	#64
	JR	Z,SETPAGE_WAIT

	LD	A,#20
	OUT	(0x64),A
	LD	A,(PAGE)
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	ADD	A
	OUT	(0x63),A
	RET

BULLETS_CP:
	.db	32,21
B_SX:	.dw	512+64	; SX
B_SY:	.dw	256+24	; SY
B_DX:	.dw	0	; DX
B_DY:	.dw	0	; DY
B_NX:	.dw	2	; NX
B_NY:	.dw	2	; NY
	.db	0,12 ;0b00011100	; 0,OPRATIE
	.dw	0xFFFF	; COLOR MASK      
	.db	0,0	; COLOR      
	.db	0,0	;      
	.db	64	; OPCODE 

TNK_COPY:
	.db	32,21
T_SX:	.dw	0	; SX
T_SY:	.dw	0	; SY
T_DX:	.dw	0	; DX
T_DY:	.dw	0	; DY
T_NX:	.dw	16	; NX
T_NY:	.dw	16	; NY
	.db	0,0b00011100	; 0,OPRATIE
	.dw	0xFFFF	; COLOR MASK      
	.db	0,0	; COLOR      
	.db	0,0	;      
	.db	64	; OPCODE    


DO_COPY:
SX:	.dw	0	; SX
SY:	.dw	0	; SY
DX:	.dw	0	; DX
DY:	.dw	0	; DY
NX:	.dw	16	; NX
NY:	.dw	16	; NY
	.db	0,12	; 0,OPRATIE 
	.dw	0xFFFF	; COLOR MASK     
	.db	0,0	; COLOR     
	.db	0,0	;     
	.db	64	; OPCODE   

TNK_POWER:
	.db	32,21
P_SX:	.dw	512	; SX
P_SY:	.dw	256+24	; SY
P_DX:	.dw	0	; DX
P_DY:	.dw	0	; DY
P_NX:	.dw	16	; NX
P_NY:	.dw	4	; NY
	.db	0,12 ;0b00011100	; 0,OPRATIE
	.dw	0xFFFF	; COLOR MASK      
	.db	0,0	; COLOR      
	.db	0,0	;      
	.db	64	; OPCODE  

MSEL_LINE:
	.db	36,17	; REG 36 , 17 BYTES
M_DX:	.dw	145	; DX
M_DY:	.dw	145	; DY
M_NX:	.dw	45	; NX
M_NY:	.dw	45	; NY
M_ARG:	.db	0,12	; 0,OPRATIE
	.dw	0xFFFF	; COLOR MASK
	.db	0,0	; COLOR    
	.db	0,0	;    
	.db	0b10110000	; OPCODE 
CPYTT:
	.ds	200
	;         1 = TNK NR

